﻿using System;
using System.Collections.Generic;
using System.Text;

namespace imlac
{
    public class Helpers
    {
        public static string ToOctal(ushort value)
        {
            string result = String.Empty;

            for (int i = 5; i >= 0; i--)
            {
                int digit = value / (int)Math.Pow(8, i);
                value -= (ushort)(digit * Math.Pow(8, i));

                result += (char)('0' + (char)digit);
            }

            return result;
        }

        public static ushort GetUshortForOctalString(string octal)
        {
            ushort value = 0;

            for (int i = 0; i < octal.Length; i++)
            {
                if (octal[i] < '0' || octal[i] > '7')
                {
                    throw new InvalidOperationException("not an octal string");
                }

                value += (ushort)((octal[i] - '0') * Math.Pow(8, octal.Length - i - 1));
            }

            return value;
        }
    }
}
